<%@ Page language="c#" Debug="true"%>
<%@ Import namespace="Mediachase.CodeGen"%>
<%@ Import namespace="Mediachase.Ibn.Data.Meta.Management"%>
<%@ Import namespace="Mediachase.Ibn.ObjectModel"%>

<% MetaClass metaClass = (MetaClass)ObjectModelFactory.Create(); %>
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// An auto generated class. Don't modify it manually.
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Data;

using Mediachase.Ibn.Data;
using Mediachase.Ibn.Data.Sql;
using Mediachase.Ibn.Data.Meta;
using Mediachase.Ibn.Data.Meta.Management;

<% if (ObjectModelFactory.Params.ContainsKey("Using") )%>
<%{%>
<%foreach (string strUsing in ObjectModelFactory.Params["Using"].Split(new char[] { ';' }, StringSplitOptions.RemoveEmptyEntries))%>
<%{%><%=string.Format("using {0};\r\n", strUsing)%><%}%>
<%}%>

namespace <%= ObjectModelFactory.Params["Namespace"] %>
{
    <% if (ObjectModelFactory.Params.ContainsKey("AccessLevel")) {%><%= ObjectModelFactory.Params["AccessLevel"]%><%} else { %>public<%}%> partial class <%= metaClass.Name %>: BusinessObject
    {
        private MetaObjectProperty[] _exProperies = null;
        
        #region Util
        public static MetaClass GetAssignedMetaClass()
        {
             return DataContext.Current.GetMetaClass("<%= metaClass.Name %>");
        }
        #endregion
        
        #region .Ctor
        public <%= metaClass.Name %>()
             : base(<%= metaClass.Name %>.GetAssignedMetaClass())
        {
        }

        public <%= metaClass.Name %>(MetaObjectOptions options)
             : base(<%= metaClass.Name %>.GetAssignedMetaClass(), options)
        {
        }
        
        public <%= metaClass.Name %>(PrimaryKeyId primaryKeyId)
             : base(<%= metaClass.Name %>.GetAssignedMetaClass(), primaryKeyId)
        {
        }
        
        public <%= metaClass.Name %>(PrimaryKeyId primaryKeyId, MetaObjectOptions options)
             : base(<%= metaClass.Name %>.GetAssignedMetaClass(), primaryKeyId, options)
        {
        }

        public <%= metaClass.Name %>(CustomTableRow row)
             : base(<%= metaClass.Name %>.GetAssignedMetaClass(), row)
        {
        }
        
        public <%= metaClass.Name %>(CustomTableRow row, MetaObjectOptions options)
             : base(<%= metaClass.Name %>.GetAssignedMetaClass(), row, options)
        {
        }

        public <%= metaClass.Name %>(MetaClass metaType, PrimaryKeyId primaryKeyId, MetaObjectOptions options)
            : base(metaType, primaryKeyId, options)
        {
        }

        public <%= metaClass.Name %>(MetaClass metaType, CustomTableRow row, MetaObjectOptions options)
            : base(metaType, row, options)
        {
        }
        #endregion

        #region Extended Properties
        public MetaObjectProperty[] ExtendedProperties
        {
            get
            {
                if(_exProperies==null)
                {
                    List<MetaObjectProperty> retVal = new List<MetaObjectProperty>();
                    
                    foreach(MetaObjectProperty property in base.Properties)
                    {
                        switch(property.Name)
                        {
                            <%foreach(MetaField field in metaClass.Fields) %>
                            <%{%>case "<%=field.Name%>": 
                            <%}%>
                                 break;
                            default:
                                 retVal.Add(property);    
                                 break;
                        }
                    }
                    _exProperies = retVal.ToArray();
                }
                
                return _exProperies;
            }
        }
        #endregion
        
        #region Static Methods (List + GetTotalCount)
        public static <%= metaClass.Name %>[] List()
        {
            return MetaObject.List<<%= metaClass.Name %>>(<%= metaClass.Name %>.GetAssignedMetaClass());
        }
        
        public static <%= metaClass.Name %>[] List(params Mediachase.Ibn.Data.FilterElement[] filters)
        {
            return MetaObject.List<<%= metaClass.Name %>>(<%= metaClass.Name %>.GetAssignedMetaClass(),filters);
        }

        public static <%= metaClass.Name %>[] List(params Mediachase.Ibn.Data.SortingElement[] sorting)
        {
            return MetaObject.List<<%= metaClass.Name %>>(<%= metaClass.Name %>.GetAssignedMetaClass(),sorting);
        }

        public static <%= metaClass.Name %>[] List(Mediachase.Ibn.Data.FilterElementCollection filters, Mediachase.Ibn.Data.SortingElementCollection sorting)
        {
            return MetaObject.List<<%= metaClass.Name %>>(<%= metaClass.Name %>.GetAssignedMetaClass(),filters, sorting);
        }

        public static <%= metaClass.Name %>[] List(Mediachase.Ibn.Data.FilterElementCollection filters, Mediachase.Ibn.Data.SortingElementCollection sorting, int start, int count)
        {
            return MetaObject.List<<%= metaClass.Name %>>(<%= metaClass.Name %>.GetAssignedMetaClass(), filters, sorting, start, count);
        }

        public static int GetTotalCount(params FilterElement[] filters)
        {
            return MetaObject.GetTotalCount(<%= metaClass.Name %>.GetAssignedMetaClass(), filters);
        }
        #endregion
        
        #region Named Properties
        <%foreach(MetaField field in metaClass.Fields) %>
        <%{
              if (!field.DataSource.InPrimaryKey)
              {%>
        public <%=BusinessObject.GetNetTypeByMetaField(field)%> <%=field.Name %>
        {
            get
            {
                return (<%=BusinessObject.GetNetTypeByMetaField(field)%>)base.Properties["<%=field.Name %>"].Value;
            }
            <%if(!field.ReadOnly) %>
            <%{%>
            set
            {
                base.Properties["<%=field.Name %>"].Value = value;
            }
            <%}%>
        }
        <%}%>
        <%}%>
        #endregion
        
        
    }
}
